Subject: Bug#1633: [X2Go-Dev] Bug#1633: New clipboard issue in Libreoffice with X2Go

From: Ulrich Sibiller <[email-masked]>
Date: Mon, 17 Mar 2025 13:13:31 +0100

Hi,

I don't know the differences between the x2go repo (I have nothing to do
with this; I am developing solely on the arctica repo) and the arctica
repo. But since this is 3.5.99.27 there shouldn't be too many differences,
especially regarding clipboard. So this is ok.

The results are interesting (and match my assumptions). Now that we know
that the client to server synchronisation is the culprit we can deduce some
problem on the client side. I will scan the logfile later, maybe it will
shine some light on the issue. For now it might be interesting to know if
the server server clipboard can be pasted _on the client side_.

Uli

On Mon, Mar 17, 2025 at 12:55 PM Jens Reyer <[email-masked]>
wrote:

> Hi
>
>
> I recompiled nx-libs (based on the current Debian 2:3.5.99.27-2 code,
> NXAGENT Version 3.5.99.27). I hope this works, tell me if I need to switch
> to the Arctica code). There I enabled TEST and DEBUG and installed those
> packages.
> Attached is a session.log (Mate, with LibreCalc autostarted, where I first
> type in a cell, then do a successful ctrl+c, ctrl+v, then a failed one and
> then a successful one.
>
>
> results for different clipboard settings:
>
> Clipboard bidirectional between client and server: first, and then every
> second attempt work
>
> Clipboard client to server: half of the attempts fail, no clear pattern
> which ones fail
>
> Clipboard server to client: everything works
>
> Clipboard between server and client disabled: everything works
>
>
>
>
> Thanks!
>
>
> Ulrich Sibiller <[email-masked]> hat am 13. März 2025 um 15:15
> geschrieben:
>
> Hi,
>
> disabling clipboard via these setting will effectively suppress
> communication between the client and the server regarding clipboard. All
> clipboard communication will then happen between libreoffice and the
> nxagent on the server side. No remote communication involved, not slowing
> down anything.
>
> So chances are that your communication is too slow. I _think_ playing
> around with the other clipboard options will show that it works with one of
> the "copy from X to Y" options and not with the other. Can you confirm?
>
> Uli
>
>
> On Thu, Mar 13, 2025 at 3:03 PM Jens Reyer <[email-masked]>
> wrote:
>
> I did the lightweight test on the client side, my local PC at work.
>
>
> And indeed, if I open a Mate x2go session to localhost's IP on the
> Linuxmint 22.1 Mate client (so server and client are the same, just
> different users) I can NOT reproduce the issue.
>
>
> Now I connected from another client/PC to my PC (so what's usually a
> client acted now as remote server): the issue still exists but only in
> about HALF of the cases, while it previously existed consistently in every
> case after the first try.
>
>
> In the original tests the server's were VMs (Proxmox PVE).
>
>
>
> Tests with connection settings:
>
>
> Previously I had the issue while connecting to the reomote server with
> connection LAN (here at work) and probably ADSL (from home). Now I tested
> the same remote server with MODEM: the issue still exists.
>
>
> Then I changed the clipboard from bi-directional (German:
> "Zwischenablage-Modus: Kopieren und Einfügen in beide Richtungen möglich"
> to disabled ("Zwischenablage komplett deaktivieren"). The issue is NOT
> reproducible anymore.
>
> So now we've found a workaround, good :)
>
>
> Setting the keyboard from auto-detect to "Model pc105, layout de" didn't
> help.
>
>
> Are there any other settings I should test?
>
> I'll recompile nxagent later.
>
>
>
> Ulrich Sibiller <[email-masked]> hat am 13. März 2025 um 13:08
> geschrieben:
>
> Hi,
>
> just to be sure: have you done the lightweight test on the server side or
> the client side?
>
> Assuming you have done the test on the server side. This indicates that
> the problem is somehow tied to the connection. Can you please check if
> different connection settings in x2go lead to different results?
>
> You don't need to compile x2goserver, just nxagent. Compiling is done like
> this:
> 1. checkout nx-libs from ArcticaProject on github
> 2. run make
>
> If this fails you probably need to install more dependencies. If it
> succeeds, you need to repeat that after changing these lines in
> nx-X11/programs/Xserver/hw/nxagent/Clipboard.c:
>
> #undef TEST -> #define TEST
> #undef DEBUG -> #define DEBUG
>
> After running make again you should find a new nxagent in
> nx-X11/programs/Xserver
>
> Uli
>
>
>
> On Thu, Mar 13, 2025 at 11:45 AM Jens Reyer <[email-masked]>
> wrote:
>
> Sorry for yet another PS:
> Yes, I may recompile a test x2goserver, if you tell me what
> changes/options you need.
>
> Jens Reyer <[email-masked]> hat am 13. März 2025 um 11:42
> geschrieben:
>
> I could NOT reproduce the problem with your lightweight test on Linuxmint
> 22.1 Mate:
>
> nxagent -ac :55
>
> DISPLAY=:55 twm
>
> DISPLAY=:55 soffice
>
> --> OK (except maybe one fail, but that was probably human failure)
>
>
> For the previous non-lightweight-test in twm on the remote Debian Trixie
> server I started in that x2go/twm session a terminal and from there
> soffice, since I couldn't find a direct Libreoffice launcher. So I tried
> this for the lightweight test - still works:
>
> nxagent -ac :55
>
> DISPLAY=:55 twm
>
> DISPLAY=:55 xterm
>
> In xterm: soffice
>
> --> OK
>
>
> I agree there must be something specific with newer Libreoffice versions,
> since I neither found this with other applications, nor with libreoffice
> 7.3.7. But as just discovered this is only an issue with (remote?) X2Go
> sessions.
>
>
> Ulrich Sibiller <[email-masked]> hat am 13. März 2025 um 10:52
> geschrieben:
>
> Ok, thanks for the information. The nxagent is the current version, that's
> ok. Also I think we take out the client from the equation.
>
> I have just tried your reproducer with LibreOffice 6.4.7.2 on RockyLinux
> 8.10 in a rootless NX session without any problems. Maybe this is tied to
> newer LibreOffice versions?
>
> You can also do a very lightweight test locally like this:
> 1. run nxagent -ac :55
> 2. DISPLAY=:55 openbox (or any other WM)
> 3. DISPLAY=:55 soffice -> will open soffice in the nx window.
>
> Is the problem showing up then, too?
>
> Maybe we need more debugging information which would require to recompile
> nxagent on your server system.
>
>
> Uli
>
> On Wed, Mar 12, 2025 at 3:00 PM Ulrich Sibiller <[email-masked]>
> wrote:
>
> Sorry, x2goserver-x2goagent is only a wrapper. The real functionality sits
> in the nxagent package, and that's the version I need. Alternatively you
> can run /usr/bin/x2goagent -version on the server.
>
> KDE includes a clipboard manager. What DE are you using?
>
> Does the problem also show up when you are using a very simple window
> manager like twm or fvwm2 or openbox?
>
> Uli
>
> On Wed, Mar 12, 2025 at 1:55 PM Jens Reyer <[email-masked]>
> wrote:
>
> Hi,
>
> thanks for the quick answer.
>
>
> x2goagent 4.1.0.6, as provided by the distributions,
>
> so on the affected Debian Trixie/Sid Mate server:
>
> x2goserver-x2goagent 4.1.0.6-1.1+b1
>
> and on LinuxMint 22.1 Mate:
>
> x2goserver-x2goagent 4.1.0.6-1.1build1
>
>
> To the best of my knowledge there's no clipboard manager running on the
> systems, neither on the 2 tested servers nor the 3 clients.
>
> Most systems were just set up recently by myself, and I never used or even
> heard about clipboardmanagers before. Neither clipman nor xclipboard are
> installed.
>
>
> Greets
>
> jre
>
>
> Ulrich Sibiller <[email-masked]> hat am 12. März 2025 um 11:13
> geschrieben:
>
> Hi,
>
>
> please let us know the version of nxagent (x2goagent) you are using. Also
> ensure that there’s no clipboard manager running (on both sides!).
>
>
> Uli
>
> On Wed, Mar 12, 2025 at 11:11 AM Jens Reyer <[email-masked]>
> wrote:
>
> Package: x2goserver
>
> Version: 4.1.0.6-1.1+b1
>
> Severity: normal
>
>
> Hi,
>
> since an update/reinstallation copy&pasting in Libreoffice in X2Go always
> needs to be repeated, only the very first run works instantly.
>
> We found this issue only when using X2Go, but not when working directly on
> the same machine.
>
> It happens only in Libreoffice (Calc and Writer), but not in e.g. Firefox
> or an editor.
>
> Starting Libreoffice in safe mode (soffice --safe-mode) does not help.
>
>
> Steps to reproduce:
>
>
> Start Libreoffice
>
> ctrl+c, ctrl+v OK
>
> ctrl+c, ctrl+v FAIL (nothing is inserted)
>
> ctrl+c, ctrl+v FAIL (nothing is inserted)
>
>
> Start Libreoffice
>
> right-click > copy, right-click > paste OK
>
> right-click > copy, right-click > paste FAIL (Libreoffice Calc asks where
> to shift the cells, but then nothing is inserted)
>
> right-click > copy, right-click > paste FAIL (Libreoffice Calc asks where
> to shift the cells, but then nothing is inserted)
>
>
> Workaround:
>
> ctrl+c, ctrl+v OK
>
> ctrl+c, ctrl+c, ctrl+v OK
>
> ctrl+c, ctrl+c, ctrl+v OK
>
>
> Tested affected servers:
>
> Debian Trixie/Sid Mate (libreoffice 4:24.8.5-2 amd64, x2goserver
> 4.1.0.6-1.1+b1)
>
> LinuxMint 22.1 Mate (libreoffice 4:24.2.7-0ubuntu0.24.04.2,
> x2goserver 4.1.0.6-1.1build1)
>
>
> Previously not affected server:
>
> LinuxMint 21.3 Mate (libreoffice 1:7.3.7-0ubuntu0.22.04.8, x2goserver
> 4.1.0.3-5)
>
>
> Tested Clients:
>
> Debian Trixie (x2goclient 4.1.2.3-3)
>
> Linuxmint 22.1 (x2goclient 4.1.2.3-1build3)
>
> Win10 (X2GoClient 4.1.2.2), with the X.org server option "do not use
> primary clipboard" both checked and unchecked
>
>
> I reported this issue only here, not with the distros or Libreoffice.
> Please tell me if I should otherwise or if I should provide additional info
> or tests.
>
>
> My boss is willing to pay for a solution. Just contact me.
>
>
> Thanks in advance and thanks for all your work!
>
> Jens Reyer
> _______________________________________________
> x2go-dev mailing list
> [email-masked]
> https://lists.x2go.org/listinfo/x2go-dev
>
> _______________________________________________
> x2go-dev mailing list
> [email-masked]
> https://lists.x2go.org/listinfo/x2go-dev
>
> _______________________________________________
> x2go-dev mailing list
> [email-masked]
> https://lists.x2go.org/listinfo/x2go-dev
>
>
>
> _______________________________________________
> x2go-dev mailing list
> [email-masked]
> https://lists.x2go.org/listinfo/x2go-dev
>
> _______________________________________________
> x2go-dev mailing list
> [email-masked]
> https://lists.x2go.org/listinfo/x2go-dev
>